<?php

declare(strict_types=1);

namespace App\Service;

use App\Repository\TblOfertaFavoritaUsuarioRepository;

final class TblOfertaFavoritaUsuarioService
{
    private TblOfertaFavoritaUsuarioRepository $TblOfertaFavoritaUsuarioRepository;

    public function __construct(TblOfertaFavoritaUsuarioRepository $TblOfertaFavoritaUsuarioRepository)
    {
        $this->TblOfertaFavoritaUsuarioRepository = $TblOfertaFavoritaUsuarioRepository;
    }

    public function checkAndGet(int $TblOfertaFavoritaUsuarioId): object
    {
        return $this->TblOfertaFavoritaUsuarioRepository->checkAndGet($TblOfertaFavoritaUsuarioId);
    }

    public function getAll(): array
    {
        return $this->TblOfertaFavoritaUsuarioRepository->getAll();
    }

    public function getOne(int $TblOfertaFavoritaUsuarioId): object
    {
        return $this->checkAndGet($TblOfertaFavoritaUsuarioId);
    }

    public function create(array $input): object
    {
        $TblOfertaFavoritaUsuario = json_decode((string) json_encode($input), false);

        return $this->TblOfertaFavoritaUsuarioRepository->create($TblOfertaFavoritaUsuario);
    }

    public function update(array $input, int $TblOfertaFavoritaUsuarioId): object
    {
        $TblOfertaFavoritaUsuario = $this->checkAndGet($TblOfertaFavoritaUsuarioId);
        $data = json_decode((string) json_encode($input), false);

        return $this->TblOfertaFavoritaUsuarioRepository->update($TblOfertaFavoritaUsuario, $data);
    }

    public function delete(int $TblOfertaFavoritaUsuarioId): void
    {
        $this->checkAndGet($TblOfertaFavoritaUsuarioId);
        $this->TblOfertaFavoritaUsuarioRepository->delete($TblOfertaFavoritaUsuarioId);
    }
}
